src/cas/urls.py
from django.urls import path, include
from django.views.generic import RedirectView
from django.contrib import admin
from django.conf import settings


admin.site.site_header = settings.SITE_TITLE


urlpatterns = [
    path('', RedirectView.as_view(url=settings.LOGIN_REDIRECT_URL, permanent=False)),

    # django-cas-provider
    path('cas/', include('cas_provider.urls')),

    path('openid/', include('oidc_provider.urls', namespace='oidc_provider')),

    # Admin panel
    path('admin/doc/', include('django.contrib.admindocs.urls')),
    path('admin/', admin.site.urls),

    path('accounts/', include('accounts.urls')),
    path('email/', include('emails.urls')),
    path('services/', include('services.urls')),
    path('ssh/', include('ssh_keys.urls')),
    path('auth/', include('django.contrib.auth.urls')),
]


if settings.DEBUG:
    from django.conf.urls.static import static
    urlpatterns += static(
        settings.MEDIA_URL,
        document_root=settings.MEDIA_ROOT
    )

src/services/urls.py
from django.urls import path
from . import views


urlpatterns = [
    path('', views.ServicesView.as_view(), name='services'),
    path('<int:pk>/', views.ServiceDetail.as_view(), name='service_detail'),
    path('<int:pk>/ssh/authorized_keys', views.SshAuthorizedKeysView.as_view()),
]

src/services/models.py
import secrets
from django.conf import settings
from django.contrib.auth.models import User
from django.db import models
from django.urls import reverse
from django.utils.translation import gettext_lazy as _


class Service(models.Model):
    name = models.CharField(_('name'), max_length=255)
    url = models.URLField(_('URL'), blank=True)
    key = models.CharField(_('key'), max_length=255, blank=True)
    uses_ssh = models.BooleanField(_('uses SSH'), default=False)

    for_all = models.BooleanField(_('for all'), default=False)
    description = models.TextField(_('description'), blank=True)
    icon = models.FileField(_('icon'), blank=True, upload_to='service/icon')

    groups = models.ManyToManyField('auth.Group', verbose_name=_('groups'), blank=True)
    users = models.ManyToManyField(settings.AUTH_USER_MODEL, verbose_name=_('users'), blank=True)

    class Meta:
        ordering = ('name', )
        verbose_name = _('service')
        verbose_name_plural = _('services')

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse('service_detail', args=[self.pk])
    
    def save(self, *args, **kwargs):
        if not self.key:
            self.key = secrets.token_urlsafe()
        return super().save(*args, **kwargs)

    def all_users(self):
        return User.objects.filter(
                models.Q(service=self) |
                models.Q(groups__service=self)
            ).distinct()

    @classmethod
    def for_user(cls, user):
        return cls.objects.filter(
            models.Q(for_all=True) | models.Q(users=user) | models.Q(groups__user=user)
        )


class Hook(models.Model):
    service = models.ForeignKey(Service, on_delete=models.CASCADE)
    email = models.CharField(max_length=255)

src/ssh_keys/models.py
from django.conf import settings
from django.db import models
from django.utils.translation import gettext_lazy as _
from .utils import get_key_details


class SSHKey(models.Model):
    user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, verbose_name=_('user'))
    key = models.TextField(_('key'))
    comment = models.CharField(_('comment'), max_length=255, editable=False)
    algorithm = models.CharField(_('algorithm'), max_length=32, editable=False)
    bit_length = models.IntegerField(_('bit length'), null=True, editable=False)
    sha256_hash = models.CharField(_('SHA256 hash'), max_length=128, editable=False)
    md5_hash = models.CharField(_('MD5 hash'), max_length=128, editable=False)
    created_at = models.DateTimeField(_('created at'), auto_now_add=True)
    last_seen_at = models.DateTimeField(_('last seen at'), null=True, editable=False)

    class Meta:
        ordering = ['created_at']
        verbose_name = _('SSH key')
        verbose_name_plural = _('SSH keys')
        unique_together = [('algorithm', 'bit_length', 'md5_hash')]

    def __str__(self):
        return self.comment

    def save(self, *args, **kwargs):
        det = get_key_details(self.key)
        self.comment = det['comment'][:255]
        self.algorithm = det['algo']
        self.bit_length = det['bits']
        self.md5_hash = det['md5']
        self.sha256_hash = det['sha256']
        return super().save(*args, **kwargs)

src/services/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic import DetailView, ListView
from .models import Service


class SshAuthorizedKeysView(DetailView):
    model = Service
    template_name = 'services/ssh_authorized_keys.txt'
    content_type = 'text/plain'

    def get_object(self):
        obj = super().get_object()
        if self.request.GET.get('key') != obj.key:
            obj = None
        return obj


class ServicesView(LoginRequiredMixin, ListView):
    def get_queryset(self):
        return Service.for_user(self.request.user)


class ServiceDetail(LoginRequiredMixin, DetailView):
    def get_queryset(self):
        return Service.for_user(self.request.user)

src/services/templates/services/base.html
{% extends "account/base.html" %}

{% block menu %}
  {% with menu="services" %}
    {{ block.super }}
  {% endwith %}
{% endblock %}

src/services/templates/services/service_detail.html
{% extends "services/base.html" %}
{% load i18n %}


{% block accounts-content %}
  <h1>{% translate "Service" %}: {{ service.name }}</h1>

  {% if service.url %}
    {{ service.url }}
  {% endif %}

  {% if service.uses_ssh %}
    {% url 'ssh_keys' as url_ssh_keys %}
    {% if request.user.sshkey_set.exists %}
      {% blocktrans %}
        This service will use your <a href="{{ url_ssh_keys}}">SSH keys.</a>
      {% endblocktrans %}
    {% else %}
      <div class="alert alert-warning">
        {% blocktrans %}
          This service uses SSH keys.
          You can add one in the <a href="{{ url_ssh_keys }}">SSH keys</a> section.
        {% endblocktrans %}
      </div>
    {% endif %}
  {% endif %}

  {{ service.description|safe|linebreaks }}
{% endblock %}

src/services/templates/services/service_list.html
{% extends 'services/base.html' %}
{% load i18n %}

{% block accounts-content %}
  <h1>{% translate "Services" %}</h1>

  <div class="service-list">
    {% for service in object_list %}
      <a class="service" href="{% if service.url %}{{ service.url }}{% else %}{% url 'service_detail' service.pk %}{% endif %}" title="{{ service.name }}">
        {% if service.icon %}
          <img class="service-icon" alt="{{ service.name }}" src="{{ service.icon.url }}">
        {% else %}
          <span class="service-name">
            {{ service.name }}
          </span>
        {% endif %}
      </a>
    {% endfor %}
  </div>

{% endblock %}